
#use Algebraico;
#use TraAbrev;

package Simusol::ParaPlot;

use strict;
use warnings;    
use Simusol::AyudasPP;

use Simusol::Globales;

use Data::Dumper;
    
my $progname;
#$my %opt_hash={};
our $unidadtiempo;
our $todas; #$opt_hash{todas}) 

our %nombreshash;
our $ref1;  # ver si viene de otro modulo

#Poner archivo a leer desde share, unidades por defecto
my $unidaddef=<<'FINAL';
plantilla=Termico
R:C/W,resistencia_termica
C:J/C,capacidad_de_acumulacion
J:W,flujo_de_calor,FLUJO
E:C,temperatura,TEMP
plantilla=Electrico
R:Ohm,resistencia
C:F,capacitancia
E:V,tension,V
J:A,corriente,I
L:H,inductancia
M:H,mutua
FINAL
#Termico:R:C/W:resistencia_termica
#Termico:C:J/C:capacidad_de_acumulacion
#Termico:J:W:flujo_de_calor,FLUJO
#Termico:E:C:temperatura,TEMP
#Electrico:R:Ohm:resistencia
#Electrico:C:F:capacitancia
#Electrico:E:V:tension,V
#Electrico:J:A:corriente,I
#Electrico:L:H:inductancia
#Electrico:M:H:mutua
#Plantilla = Generico
our $tablauni={};
our $tablaunisimul={};
leeUNIDADES($unidaddef,$tablauni);




# aqui se guardan referencias a las variables propias

# abril 2006 en el paraplot los numeros se refieren a las variables propias
# si no se indican indices es porque son los naturales
# ----------------------------------------------------------------------------
sub inicio{
    my ($commlineinfo)=@_;
    $todas=$commlineinfo->{opciones}->{todas};
    $progname=$commlineinfo->{progname};  
    $unidadtiempo='horas';
    %nombreshash = ('TIME'=>1,'TIEMPO'=>1);
    
}
#########################################################################
sub leeUNIDADES{
    my ($unidadesdef,$tablauni)=@_;
my @unidef=split(/\n/,$unidaddef);
my $plantilla='';
foreach (@unidef){
    chomp $_;  
    if ($_=~/plantilla\=([a-zA-Z0-9_]+)/){	
	#print "PLANTILLA $1\n";
	if (defined $1 and $1){
	    $plantilla=$1;
	}
    }else{
        $_=~s/,/:/;    # ojo solo la primera
        my ($elemento,$unidad,$magnitud)=split(/:/,$_);
        $tablauni->{$plantilla}->{$elemento}=[$unidad,$magnitud];
        }
    }
}

sub leeUNIDADESdeSIMUL{
    my ($unidades,$magnitudes,$variables,$cartelvar, $tablaunisimul)=@_;

    my $cu= scalar    @$unidades;
    my $mag= scalar    @$magnitudes;
    my $nvar= scalar @$variables;
    my $ncvar= scalar @$cartelvar;
    if ($cu != $mag or $cu != $nvar or $cu != $ncvar ){
	warn "NUM_MAGNITUDES: $mag NUM_unidades: $cu NUM_VAR_SIMUL: $nvar, CARTEL: $ncvar,  no son todos iguales";
	return;
    }
    foreach (0..$cu-1){           
        $tablaunisimul->{$variables->[$_]}=[$unidades->[$_],$magnitudes->[$_],$cartelvar->[$_]];
        }
}

#print Dumper $tablauni;
#exit;
# -----------------------------------------------------------------------------

sub settime{
    my ($t)=@_;
    $unidadtiempo=$t;
}
####################################################################################################

sub pararenglones{
    my($paraplot,$archivos,$elemento)=@_;
    
           my @renglones;
           my $date;
           if ($paraplot){
                @renglones = split(/\n/,$paraplot);
	        $date="SIN ARCHIVO ".localtime();
           }else{
             # caso simul, no hay variable paraplot   
             my ($archpara,$x1,$x2)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.paraplot','');  
             # sacar paraplot de hash
             ############################## OJO ACA OBLIGA A USA NOCLASS para .paraplot que estan en el camino MAL
             # discrtiminar si son argumentos!!!!! para leer y ya sabemos donde estan o si es escritura
             #print "ELEMENTO $elemento, $archpara\n";
     
             if (-e "$archpara"){
                  $date = scalar localtime((stat "$archpara")[9]);
             }else{	 
 	          warn "no hay $archpara, no puedo procesar este $elemento";
                  }
      
             #print "PLOT $archpara\n";
             #      print Dumper $archivos; 
             #      exit;      
             my $DIRC=$archivos->{curdir};

             my $ok=  open my $ENTRADA,  "$archpara" ;
             if (not $ok) {                                        # REVISAR
                  warn "No existe el archivo $archpara dir:$DIRC";
             }else{
                  #Simusol::AyudasPP::parar3(12,"No existe el archivo $archpar dir:$DIRC");
                  @renglones = <$ENTRADA>;
                  close $ENTRADA;
                  }
             }

           Simusol::AyudasPP::mensaje('=-' x 2 ."Mensajes de simplot,         $elemento, "
		   . $date);
	   chomp @renglones;

	   return($date,\@renglones);
        }

           


#####################################################################################################
sub escribepara{
    my ($GRAFICOS,$file,$archivos,$elemento)=@_;

    # if ($paraplot){ 
    #      open (PARAPLOT, ">$archguardarcongnus.paraplot");
    #      print PARAPLOT "# Archivo $archguardar.paraplot; preparado por $progname
    ## a partir del archivo $PROPIO  de fecha $date
    ##         para pedir gráficos a simusol3.pl\n";
    #      print PARAPLOT "$paraplot";
    #      close(PARAPLOT);
    #  };

    # si no hay resultados??? como sale outs?


    #    print "AGRE $GRAFICOS\n";
   


     
     #print "FILE $file\n";
     
#	my $file;
#	if ($camino){
#	    $file=File::Spec->catfile($camino,"$CORTOSIN.paraplot");
#	}else{
 #           $file="$CORTOSIN.paraplot";
#	}
    #print "grabando paraplot $file\n";
        Simusol::AyudasPP::archiva($file,'F',$archivos,$elemento); 
        open(my $fh, '>', $file)   or die "Can't open  $file: $!";
        print $fh $GRAFICOS;
        close $fh;
   
   # exit;
    
}
###########################################
sub muestra_refcircuito{

my ($refcircuito)= @_;

 print Dumper $refcircuito->{lisoutputssceptre};
  #    $VAR1 = [
 # 'TIME',
 # 'VCA',
 # 'IR5',
 # 'J1'
#];
 
 print Dumper $refcircuito->{lispropiasvars};

#$VAR1 = [
#  'TIEMPO',
#  'TEMP 1',
#  'FLUJO R5',
#  'J1'
#];

 print Dumper $refcircuito->{lisunidadesj};
 #$VAR1 = undef;
 print Dumper $refcircuito->{lismagnitudes};
 #$VAR1 = [
  #'tiempo',
  #'temperatura',
  #'flujo_de_calor',
 # 'flujo_de_calor'
#];
 print Dumper $refcircuito->{indicebueno};
 #$VAR1 = [
 # 1,
#  2,
#  3,
#  4
#];
 print Dumper $refcircuito->{lispropiasvars};
 #$VAR1 = [
  #'TIEMPO',
  #'TEMP 1',
  #'FLUJO R5',
 # 'J1'
#];
 print Dumper $refcircuito->{rerun};
 #$VAR1 = {
 # 'PARAMETROS' => {}
#};
 print Dumper $refcircuito->{marcasrerun};

#$VAR1 = '';
 print Dumper  $refcircuito->{archrerun};
 #$VAR1 = 'tanque.simul';
 print Dumper  $refcircuito->{PROPIO};
 #$VAR1 = 'tanque.dia';
 print Dumper $refcircuito->{CORTO};
 #$VAR1 = 'tanque.dia';


 print Dumper $refcircuito->{clasearch};
 #$VAR1 = 'circuito';
 print Dumper $refcircuito->{refvalores}->{GRAFICOS};

#$VAR1 = undef;  
 print Dumper $refcircuito->{lisnum};

#$VAR1 = {
  #'flujo_de_calor,W' => [
  #  3,
  #  4
  #],
  #'temperatura,gradoC' => [
   # 2
  #]
 # };
 print Dumper $refcircuito->{refvalores}->{AGREGAR_GRAFICOS};
 
#$VAR1 = undef; 


}

# ----------------------------------------------------------------------------
sub ident_simulado{
    Simusol::AyudasPP::comfin('comP ident_simulado',@_);
    
   my ($refcircuito, $archguardar) = @_;
    Simusol::Globales::impr_RESULTADOS(__LINE__.' Prog',$refcircuito);
  #impr( __LINE__."Prog  propiasvar "
   #  , $refcircuito->{lispropiasvars});
  #impr( __LINE__."Prog  sceptre "
  #   , $refcircuito->{lisoutputssceptre});
  my $archivo = $refcircuito->{CORTO};
  my ($sceptrevars,$unidades,$propias,$magnitudes) = ('','','','');
  my $paraplotSIMULADO = '';
  $sceptrevars = join ',',@{$refcircuito->{lisoutputssceptre}};
  $propias = join ',',@{$refcircuito->{lispropiasvars}};
  my @lisunidades = @{$refcircuito->{lisunidades}};
  $lisunidades[0]= 'seg';
  $unidades =  join ',',@lisunidades;
  $magnitudes =  join ',',@{$refcircuito->{lismagnitudes}}; 
    my @indicebueno = @{$refcircuito->{indicebueno}};


   # print "INDICEBUENO @indicebueno \n";

   # exit;
    


    
  my @lista =  @{$refcircuito->{lispropiasvars}};
  for (my $i = 0; $i < @lista; $i ++) {
      $lista[$i] =~ s/\s//g;
      $nombreshash{uc($lista[$i])} = $i+1;
  };
  $paraplotSIMULADO =  "sceptrevars SIMULADO = $sceptrevars\n" .  
        "archivo SIMULADO = $archguardar\n" .
        "variables SIMULADO = $propias\n" .
        "unidades  SIMULADO = $unidades\n" .
        "magnitudes SIMULADO = $magnitudes\n";
  #sceptrevars  lo usa simusol2.pl;  pero no simusol3.pl salvo que se deje 
  #indices SIMULADO = 1,...
  my $referencia = '';
  if (not grep('??',@lista)) {
      $referencia = 1; 
      # significa que hay errores en los pedidos
  } else { 
      for(my $i = 0; $i < @indicebueno; $i ++) {
	  $indicebueno[$i] ne $i+1 and $referencia = 1;
      };
  };
  if ($referencia) {
      my $tira = join ', ', @indicebueno;
      $paraplotSIMULADO .= "indices SIMULADO = $tira\n";  
  };
    #Simusol::Globales::impr_debug(__LINE__.' Prog rerun', Dumper $refcircuito->{rerun});
    #print "RERUN ",  Dumper $refcircuito->{rerun};
    
    # no pongo sort pq suele ser vacio y devuelve un numero
  if (scalar keys %{$refcircuito->{rerun}} 
       and  defined $refcircuito->{marcasrerun} 
       and $refcircuito->{marcasrerun}) {
        $paraplotSIMULADO .= 
            "arch_var SIMULADO = $refcircuito->{archrerun}\n";
        $paraplotSIMULADO
          .= "variaciones SIMULADO = $refcircuito->{marcasrerun}\n"
  };
    Simusol::AyudasPP::comfin('finP ident_simulado $paraplotSIMULADO',$paraplotSIMULADO);

   # print "$paraplotSIMULADO\n";
   # exit;
    
  return $paraplotSIMULADO;  
} #ident_simulado
# ----------------------------------------------------------------------------
sub inventar_graficos{
    Simusol::AyudasPP::comfin('comP inventar_graficos',@_);
    
  my ($refcircuito,$archguardar) = $_[0];
 
 my $PROPIO = $refcircuito->{PROPIO};
    my $ngraf = 'graf00';
    my $NGRAF=0;
  my $todotextos=''; 
 
  my $textojuntos='';
  my (%textos,@simbograf);
  my $mens_sincuadro = "---- Recuerde que puede:
               pedir gráficos en un cuadro GRAFICOS 
               o pedir gráficos en forma interactiva ejecutando
                    simusol -graf 1 $PROPIO" ;
  our @mens = split "\n", $mens_sincuadro;		     
  my @lisunidades = @{$refcircuito->{lisunidades}};
  my @lismagnitudes = @{$refcircuito->{lismagnitudes}};
  my @lispropiasvars = @{$refcircuito->{lispropiasvars}};
  my @lisoutputssceptres = @{$refcircuito->{lisoutputssceptre}};
  my @indicebueno = @{$refcircuito->{indicebueno}};
  #Simusol::Globales::impr_RESULTADOS(__LINE__.' Prog inv.gra', $refcircuito);

#    print Dumper $refcircuito->{listapedidos},$refcircuito->{lispropiasvars};###,$refcircuito;


    # OJO ESTE TRADVAR es al vicio, el que importa es el leido junto a caj en simplot, producido por simusol04
    my $tradvar={};
    my @q=();
    #print "MMM\n";
    foreach ( @{$refcircuito->{listapedidos}}){
	my $rrr=$_;
	$rrr=~s/\)\s*//;
	$rrr=~s/([^,\(\s]*)//;
	my $res=$1;
	$rrr=~s/^\s*\(\s*//;
        my ($a,$b,$c)=split(/,/,$rrr);
	#print "$rrr XXX $res - $a - $b - $c\n";
        push (@q,[$res,$a]);
        }
   #exit;
    
  my @qq=();
  foreach ( @{$refcircuito->{talcualbuenos}}){
	my $rrr=$_;
	$rrr=~/([^,\(]*)/;
	my $res=$1;
	push (@qq,$res);
        }

    
  #  print "QQ @q\n";
  #  print "QQQ @qq\n";
    my $cant=scalar @{$refcircuito->{listapedidos}};
    $tradvar->{TIEMPO}='TIME';
    foreach (0 .. $cant-1){
	#print "ZZZ $qq[$_], $q[$_] \n";
	$tradvar->{$qq[$_]}=$q[$_];
        }

#    print "$archguardar ", Dumper $tradvar;
    
    
# print Dumper $refcircuito->{talcualbuenos};
#,$refcircuito->{lisoutputssceptre};#,

 #   exit;

  foreach my $key (@{$refcircuito->{listalisnum}}) {
      #print "LINEAPUNTO $key\n";
      #%{$refcircuito->{lisnum}} :
      #key: el par de nombre de magnitud, unidad; 
      #value: la lista de los numeros de variables 
      #que corresponden a esa magnitud
      my ($coderr,$nombre,$uni) = Simusol::AyudasPP::juntar_por_paren(','
              ,split('\s*,\s*', $key));
      #Simusol::Globales::impr_debug(__LINE__.' Prog $uni $nombre', "$uni, $nombre");
      $uni =~ s/\s*\S+\s+(\S+)/$1/; # el eventual factor quedará registrado
      #en las unidades, en el archivo .paraplot 
      if (not defined $refcircuito->{lisnum}->{$key}) {
           Simusol::AyudasPP::avnograv("Hay mezcla no conveniente de elementos de 
              plantillas distintas");
          next;
      };
      $ngraf ++;
      $NGRAF = uc($ngraf);
      #print "NGRAF $ngraf - $NGRAF\n";
      #exit;
      
      my $listita = join ',', @{$refcircuito->{lisnum}->{$key}};
      push @simbograf, $NGRAF;
      $textos{$key} = "lineas $NGRAF = SIMULADO, 1 : $listita\n"; 
      $todotextos .= $textos{$key}; 
  }; # 
  my $juntotextos='';

  for (my $gg= 0; $gg< @simbograf; $gg += 2) {
      last if $gg+1 == @simbograf;
      $ngraf ++; 
      $NGRAF = uc($ngraf);
      $textojuntos .=
            "mostrarjuntos $NGRAF = $simbograf[$gg], $simbograf[$gg+1]\n"
           . "nomostrar $simbograf[$gg], $simbograf[$gg+1]\n";
  }; 
  map ($juntotextos .= "echo $NGRAF = $_\n", @mens); 
  my $agregartextos = ''; my @uniprilista; 


  if (defined $refcircuito->{refvalores}->{AGREGAR_GRAFICOS} ) {
      my %todos = %{$refcircuito->{refvalores}->{AGREGAR_GRAFICOS}}; 
      foreach (keys %todos) {
          my $vielista = $todos{$_};
          my @vielista = Simusol::AyudasPP::juntar_por_signos_y_paren(',', @$vielista);
          my @pegados = grep (/=.*=/,@vielista);
         if (@pegados) { 
               Simusol::AyudasPP::avnoseent("Los \"renglones\" del cuadro AGREGAR_GRAFICOS\n" .
                        join ("\n", @pegados) . "
             quizás un renglón terminado por error con coma 
                  se pegó al siguiente");
          };                     
          @vielista = grep($_!~ /=.*=/,@vielista);
          @vielista and $agregartextos .= join ("\n", @vielista) ."\n";
          push @uniprilista, grep(/unipri\s*SIMULADO/,@vielista);   
      };
  };
  Simusol::Globales::impr_debug(__LINE__.' Prog $agregartextos',$agregartextos);

  @uniprilista == 0 and $agregartextos .= "unipri SIMULADO = $unidadtiempo\n";

    
  Simusol::AyudasPP::comfin('finP inventar_graficos',@_);
  return ("$textojuntos$todotextos$agregartextos",'',$tradvar);
  #va primero $textojuntos para mostrar primero los dobles graficos
} #inventar_graficos
# -----------------------------------------------------------------------


sub leecaj{
    my ($CORTO)=@_;

    my $RESULTADOS=[];
    my $GRAFICOS="";
    my $AGRAFICOS="";
    my $UNIDADES="";
    my $STOPTIME="";
    my $TIEMPO="";
    
    
 # o procesa corto (si no es simul), o procesa cantvars
      #print "HAY CORTO $CORTO\n";
      open(my $fh, "<", $CORTO)
	or die "Can't open < $CORTO: $!";
  
    my @lista=qw(RESULTADOS AGREGAR_GRAFICOS CONTROLES UNIDADES TIEMPO GRAFICOS);
     # en caj no aparecen las unidades de los dia de elementos
    my $cuadro='';	
    while (my $line = <$fh>) {
      chomp $line;
      my $cam=0;
      foreach my $cuad (@lista){       # titulos de secciones
          if ($line=~/Cuadro   $cuad/){
	      $cuadro=$cuad;
	      $cam=1;
	      last;
	      }
          }      
      if(not $cam and ($line=~/Cuadro/ or $line=~/Claves de interpretación de simusol/)){
	 $cam=1; 
	 $cuadro="";
      }
      if (not $cam){	                 # contenido de secciones
        if ($cuadro eq "RESULTADOS"){
            $line=~s/^\s+//;
            $line=~s/\s+$//;
	    if ($line=~/\(/){                      ################# OJO ESTO ES UN DISPARATE por jol,kiol, y no jol(,),
		# no es obvio separar por comas las lineas, usar ;
		 #                           no permitir mas de una variable por linea
	       push(@$RESULTADOS,$line);
	    }else{
		my @w =split(/\s*,\s*/,$line);
	       push(@$RESULTADOS,@w);
	    }
           #print "$line\n";
	}elsif($cuadro eq "GRAFICOS"){	    
	    $GRAFICOS.=$line."\n";
	   # print "$line\n";
	}elsif($cuadro eq "CONTROLES"){
	    if ($line=~/STOP_TIME/){
		$STOPTIME=$line;
	    }
            #print "$line\n";
	}elsif($cuadro eq "TIEMPO"){	    
	    $TIEMPO.=$line;
            #print "$line\n";
	}elsif($cuadro eq "UNIDADES"){	    
	    $UNIDADES.=$line;
            #print "$line\n";	    
       	}elsif($cuadro eq "AGREGAR_GRAFICOS"){	    
	    $AGRAFICOS.=$line."\n";
            #print "$line\n";
           }
        }
    }
      close $fh;

      return($RESULTADOS,$GRAFICOS,$AGRAFICOS,$TIEMPO,$STOPTIME,$UNIDADES);
}

#########################################
sub prepara{
    my ($refcircuito,$VARS,$tradvar,$RESULTADOS,$cartelvar,$unisimul,$unidef,$plantilladef,$TIEMPO,$STOPTIME,$archivos,$elemento)=@_;


           my $postiempo={'horas'=>1,'minutos'=>1,'segundos'=>1};    
          ##################################################################### OJO PASE DE GLOBAL
          # setea $unidadtiempo en paraplot.pm
          foreach my $tim (sort keys %$postiempo){
              if ($TIEMPO=~/$tim/){
                 Simusol::ParaPlot::settime($tim);
              }elsif($STOPTIME=~/$tim/){
                 Simusol::ParaPlot::settime($tim);
                 }
              }

          $refcircuito->{PROPIOSINDIA}=$archivos->{arg}->{$elemento}->{dirs}->[0]; #$PROPIOSIN;  #SOLO
          $refcircuito->{CORTOSINDIA}= $archivos->{arg}->{$elemento}->{dirs}->[2]; #$CORTOSIN;   #BASE+SOLO
          $refcircuito->{CORTO}=       $archivos->{arg}->{$elemento}->{dirs}->[4]; #$CORTO;      #BASE+SOLO+EXT
          $refcircuito->{PROPIO}=      $archivos->{arg}->{$elemento}->{dirs}->[5]; #$PROPIO;     #SOLO+EXT

     
    
    #my $cant=scalar @$VARS;
    #foreach (0..$cant-1){
    #	$sceptrevarcartel->{$CARTELVARS->[$_]}=$VARS->[$_];
    #    #print "MMM  $CARTELVARS->[$_] -        $VARS->[$_];    \n"
    #  }
    
    #print "bb ",  Dumper $sceptrevarcartel;
    #exit;
    
   my $propiavarcartel={};
    
    #print "PREPARA\n";
    my $hvar={};

    my $i=1;

     # la primera columna de simul siempre es tiempo???????, si no lo es lo imponemos?
     $VARS->[0]='TIME';
    
    foreach (@$VARS){
	$hvar->{uc($_)}=$i++;
    }
    #print Dumper $hvar;
    
#    foreach(sort keys %$tradvar){
#	if (not exists $hvar->{$tradvar->{$_}}){
#	    warn "ERROR variable en tradvar que no existe en hvar";
# y que importa????
#	}
#    }

    

     #	@{$refcircuito->{'lisoutputssceptre'}}=('TIME',@$VARS);  # estas deben venir de simul, si no hay al menos contar las columnas y revisar

    
     @{$refcircuito->{'lisoutputssceptre'}}=(@$VARS);  # estas deben venir de simul, si no hay al menos contar las columnas y revisar

    
    $refcircuito->{clasearch}="circuito";    
    ################ VER!!!!, no todos los dias contienen circuitos, o son principales
    $refcircuito->{rerun}={};                ################## COMPLETAR
    $refcircuito->{marcasrerun}="";


  


#XXXXXXXXXXXXXXXXXXXXXXXXXx
    
  #  print "MMM ", Dumper $RESULTADOS;
   #   exit;
      
   
#Plantilla = Termico
#R : gradoC/W, resistencia_termica
#C : J/gradoC, capacidad_de_acumulacion
#J : W, flujo_de_calor,FLUJO
#E : gradoC, temperatura,TEMP

#R : Ohm, resistencia
#C : F, capacitancia
#E : V, tension,V
#J : A, corriente,I
#L : H, inductancia 
#M : H, mutua

#tiempo               segundos  s
#temperatura          gradosC   C
#flujo de calor       watios    W
#resistencia_térmica  watios/gradosC W/C
#capacidad_térmica    julios/gradosC J/C



#my ($k,$ut)=split(/ /,$TIEMPO);
#$ut=~ s/\s+\,/\,/g; 
#$ut=~ s/\,\s+/\,/g;

    

   

      #print "UT : $STOPTIME - $TIEMPO \n";
      #Si esta en simusol, en vez de leer caj usar:
      #$ref->{refvalores}->{RESULTADOS}->{objetoX}=["VCC(T c,temp,C)",
      #					     "VCACU(T x,temp,C)",
      #                                            "VCC(T v,temp,C)"];
      #exit;
    
      my $ref={};
      $ref->{refvalores}->{RESULTADOS}->{objetoX}=$RESULTADOS;
    
      # si van juntos dos con la misma abscisa los mete en el mismo png "mostrarjuntos"
      # conviene que exista un solo cuadro de resultados, si hay mas cambia objetoX
      #interpretar_resultados($ref);

      # a veces hace append
      #    system "rm *.paraplot 2> /dev/null";

      $refcircuito->{'indicebueno'}=  [1];
      $refcircuito->{'lismagnitudes'} = ['tiempo'];
  
      $refcircuito->{'lispropiasvars'} = ['Tiempo'];
      $refcircuito->{'lisunidades'}=['s'];   # horas seg s

      my $indices=2;
      my $indicepp=2;
      my $numinds={};
      my $numindpp={};
      $numinds->{'TIME'}=1;
      $numindpp->{'tiempo'}=1;
      #print "CCC ", Dumper $ref->{refvalores}->{RESULTADOS}->{objetoX};


    $refcircuito->{listalisnum}=[];
    #print "TRADVAR ", Dumper $tradvar;

    #print "unisimul ", Dumper $unisimul;
    
      foreach (@{$ref->{refvalores}->{RESULTADOS}->{objetoX}}){
            $_=~s/\(/,/;
            $_=~s/\)/,/;
            #    print "$_\n";
            my @par=split (/\s*,\s*/,$_);

	    #print "RRRRRR  @par -- $_ \n";
	    
            foreach (@par){
	        $_ =~ s/\s*\,\s*/\,/g; 
                #$_ =~ s/\,\s+/\,/g;--
		#print ">$_<\n"
	    }
	    #print "PAR @par\n";
            my ($noms,$nompp,$cuadro,$uni)=@par;

	    #$noms=uc($noms);
            if (not $noms){
        	warn "Error, no hay nombre\n";
	        $noms="Disparate";
	        }
	    
	    # if ( defined  $propiavarcartel->{uc($nompp)} and $propiavarcartel->{uc($nompp)} ne $noms){
            #	print "ERROR: el mismo cartel: $nompp se usa para varias variables: $noms y  $propiavarcartel->{$nompp} ";
	    #   }else{
            #      $propiavarcartel->{uc($nompp)}=$noms;
	    #     }

	    # una vez usado eventualmente noms para fijar nompp (cartel), no sirve para nada y lo mejor es reemplazarlo por el nombre real
            my $vnoms=$noms;       	
   	    if ($noms ne 'TIME' and  $noms ne 'TIEMPO' and not exists $hvar->{$noms}){	
                    #print "$noms  @{$tradvar->{$noms}} ",  Dumper $tradvar , $hvar;	
                    if (exists $tradvar->{$noms}->[0] and exists $hvar->{$tradvar->{$noms}->[0]}){
			$noms=$tradvar->{$noms}->[0];
		    }else{
		        warn "VARIABLE PEDIDA EN RESULTADOS NO DEFINIDA en simul: $noms";
			$noms="DESC";
			$hvar->{$noms}=2;
		     }	
		}

	    
            if (not $nompp){  #magnitudes
		$nompp=$unisimul->{$noms}->[2];
	        }
            if (not $nompp){
	        $nompp=$vnoms;
	        }
           
	    
	    my $FIRST = uc(substr($noms, 0, 1));
            if (not $cuadro){  #magnitudes
		$cuadro=$unisimul->{$noms}->[1];
	        }
	    if (not $cuadro){		
		$cuadro=$unidef->{$plantilladef}->{$FIRST}->[1];
	        }
    	    if (not defined $cuadro or not $cuadro){ 
	        $cuadro=$nompp;
	        }
	     if (not $uni){  #magnitudes
		$uni=$unisimul->{$noms}->[0];
	        }
	    if (not $uni){		
		$uni=$unidef->{$plantilladef}->{$FIRST}->[0];
	        }
            if (not defined $uni or not $uni){
	        #$uni=$cuadro;
		#$uni=~s/\s//g;
                }

            if ($noms eq 'TIME' or $noms eq 'TIEMPO'){
                #descartar
            }else{
                #    print "$noms X $nompp X $cuadro X $uni \n";
                ########## horror los indices no empiezan en 0, probablemente a gnuplot no le guste
                push(@{$refcircuito->{'lismagnitudes'}},$cuadro);
		#                push(@{$refcircuito->{'lisoutputssceptre'}},$noms);
		#$noms=uc($noms);
	       
	 	#print "NOMS $noms <- $vnoms\n"; 
		    #$noms=~s/TEMP\s*/V/;  
                    #$noms=~s/FLUJO\s*/V/;
		    #if ($nompp){                   
                    #if (not exists $sceptrevarcartel->{uc($nompp)}){
		#	warn "ERROR VARIABLE PEDIDA EN RESULTADOS NO DEFINIDA en simul con cartel $nompp: $noms";
		#	print Dumper $sceptrevarcartel;
		#	exit;
		   # }else{
                    #    $noms=$sceptrevarcartel->{uc($nompp)};
		#	print "NOMS SCEPTREVAR $noms NOMPP $nompp\n";
		     #   }		  
	        #}			    		        		   		
		  #}#else{
		   #   $noms= $hvar->{$noms};		      
		   #}
	    
#	     print "NOMS $noms NOMPP $nompp\n";
		
#                if (not exists $numinds->{$noms}){
#                        $numinds->{$noms}=$indices++;
#                        }
                push(@{$refcircuito->{'lispropiasvars'}},$nompp);
                if (not exists $numindpp->{$nompp}){
                        $numindpp->{$nompp}=$indicepp++;
                        }
                push(@{$refcircuito->{'lisunidades'}},$uni);
                #push (@{$refcircuito->{'indicebueno'}},$numinds->{$noms});


		#print "INDICE BUENO $noms $hvar->{$noms}\n ";
		#print Dumper $hvar;
                # my $r=<STDIN>;
		
                push (@{$refcircuito->{'indicebueno'}},$hvar->{$noms});
              
		
                if (not exists $refcircuito->{'lisnum'}->{"$cuadro,$uni"}){
		    $refcircuito->{'lisnum'}->{"$cuadro,$uni"}=[];
		    push (@{$refcircuito->{listalisnum}}, "$cuadro,$uni");
		    # lista ordenada y con elementos unicos
                        }
                push (@{$refcircuito->{'lisnum'}->{"$cuadro,$uni"}} ,$numindpp->{$nompp});
                #$refcircuito->{'lisnum'}->{"Time,s"} agregar algo aca
                }
  
      }

    
    
#            $refcircuito->{listalisnum}=[sort keys %{$refcircuito->{'lisnum'}}];
    # no es orden correcto

    
#print "ib @{$refcircuito->{'indicebueno'}} \n";
#print "lc @{$refcircuito->{lismagnitudes}} \n";
#print "ls @{$refcircuito->{lisoutputssceptre}} \n";
#print "lpp @{$refcircuito->{lispropiasvars}} \n";
#print "lisnum", Dumper $refcircuito->{'lisnum'};
#print "s ", Dumper $numinds;
#print "pp ", Dumper $numindpp;
#print "lln 948 ", Dumper $refcircuito->{listalisnum};

#exit;


#variables sustituidas como comentario
    
# my $hayparend=system "grep $PROPIOSIN.par $PROPIOSIN.d >/dev/null 2>/dev/null";
# ya no se usaparend para ver si imprimo .par, si hay se imprime
 

}




# ---------------------------------------------------------------------------ASUS

####################################################################
sub relativosparaplot{ 
my ($archivos,$elemento,$paraplot)=@_;       
    my ($file,$dirarchivo,$bn)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.paraplot','');
    Simusol::AyudasPP::creacamino($dirarchivo,$archivos,$elemento,0);
    $archivos->{arg}->{$elemento}->{paraplot}->{esta}=$file;  
    $archivos->{arg}->{$elemento}->{paraplot}->{dir}=$dirarchivo;  

    my $Tparaplot;
    my @GRA=();
    if (defined $paraplot and $paraplot){
	@GRA=split(/\n/,$paraplot);
        }
     $Tparaplot="";
     foreach (@GRA){
	 #print "MM $_\n";   #### pueden ser varios archivos en arch_var, trans en archsimul se encarga	
	 if ( $_=~s/^(\s*)archivo ([a-zA-Z0-9_]+) = (.*)$/"archivo $2 = ".Simusol::ArchSimul::trans($3,$dirarchivo,$archivos,$elemento)/e){
	    # print "ARCHIVO $_ - $3 \n";
	 }
	  if ( $_=~s/^(\s*)arch_var ([a-zA-Z0-9_]+) = (.*)$/"arch_var $2 = ".Simusol::ArchSimul::trans($3,$dirarchivo,$archivos,$elemento)/e){
	     #print "ARCH_VAR $_\n";
	 }
	 $Tparaplot.=$_."\n";
         }
    $paraplot=$Tparaplot;

 return ($paraplot,$file);   
}

#########################################################################################





sub prograficarASUS{
  
  # prepara archivo .paraplot con informacion para graficos.
#  impr_todo(__LINE__.' Prog',$ref1);  

  my ($refcircuito,$archivos,$elemento,$nombredatos) = @_;

  
  #print   Dumper  $refcircuito;
  #exit;
  

  Simusol::AyudasPP::comfin('comP prograficar',@_);
  #exit;


  $Simusol::Globales::ref1->{PROPIOSIN}=$refcircuito->{PROPIOSINDIA};
  
  my $archguardar = $Simusol::Globales::ref1->{PROPIOSIN}; 
  my $archguardarcongnus = $Simusol::Globales::ref1->{ARCHGUARDARCONGNUS};
  my $PROPIO = $Simusol::Globales::ref1->{PROPIO};
  my $CORTO = $Simusol::Globales::ref1->{CORTO};
  my $date = $Simusol::Globales::ref1->{DATECORTO};
  my $paraplotSIMULADO = '';

  $Simusol::Globales::ref1->{CLASEARCH}='circuito';
  if ($Simusol::Globales::ref1->{CLASEARCH} eq 'circuito') {

      ##########  este es el que crea el encabezado de archivos, magnitudes, unidades
      $paraplotSIMULADO = ident_simulado($refcircuito,$nombredatos);
# devuelve hasta antes de las lineas o puntos    
      };


my $tradvar;
  
  my ($paraplot, $haysimulado, @uniprilista) = ('',0,());
  if (scalar keys %{$refcircuito->{refvalores}->{GRAFICOS}}) {
      #solo se haran los graficos pedidos aqui
      my %todos = %{$refcircuito->{refvalores}->{GRAFICOS}}; 
      foreach (sort keys %todos) {
          my $vielista = $todos{$_};
          my @vielista = juntar_por_signos_y_paren(',', @$vielista);

          #print "TODOS $_   $todos{$_} , @vielista ";	  
	  Simusol::Globales::impr_debug(__LINE__.' Prog @vielista', \@vielista);
          my @pegados = grep (/=.*=/,@vielista);
          if (@pegados) { 
              avnoseent("Los \"renglones\" del cuadro GRAFICOS\n" .
                        join ("\n", @pegados) . "
             quizas un renglon terminado por error con coma 
                  se pego al siguiente");
          };                     
          @vielista = grep($_!~ /=.*=/,@vielista);
	  Simusol::Globales::impr_debug(__LINE__.' Prog @vielista', \@vielista);

          @vielista and do{
               $paraplot = $paraplotSIMULADO . join("\n",@vielista). "\n"; 
          };
          $haysimulado += scalar (grep(/=\s*SIMULADO\s*\,/i,@vielista));
          push @uniprilista, grep(/unipri\s*SIMULADO/,@vielista);   
      }; #foreach


     
      
   
      Simusol::Globales::impr_debug(__LINE__.' Prog $haysimulado @uniprilista',
              , [$haysimulado, @uniprilista]);
      $haysimulado and @uniprilista == 0 and
          $paraplot .= "unipri SIMULADO = $unidadtiempo\n";  
      #Simusol::Globales::impr_debug(__LINE__.' Prog $paraplot', $paraplot); 
  } else {
      ################## aqui agrega al paraplot las lineas y puntos
 
      (my $paraplottextos,$haysimulado,$tradvar) = inventar_graficos($refcircuito, $archguardar);


      #print "tradvar ", Dumper $tradvar;
      
      if ($paraplottextos) {
	  #print ">>>> $paraplottextos   paraplot.pm 356\n";
          $paraplot = "$paraplotSIMULADO$paraplottextos";
	  #exit;
	  
      } else {
          mensajear(" No hay pedido de graficos, directo ni por defecto");
          Simusol::AyudasPP::comfin('finP prograficar');
          return 1;
      };
  };
  Simusol::Globales::impr_debug(__LINE__.' Prog $paraplot $archguardarcongnus'
                ,[$paraplot,$archguardarcongnus]);
 
# if ($paraplot and 1==2){
#      Simusol::AyudasPP::impr_todo(__LINE__.' Prog',$Simusol::Globales::ref1);
#      Simusol::AyudasPP::eco (" Voy a escribir el archivo $archguardarcongnus.paraplot");
#      Simusol::AyudasPP::archiva("$archguardarcongnus.paraplot",'F',$archivos,$elemento); 
#      open (my $PARAPLOT, ">$archguardarcongnus.paraplot");
#      print $PARAPLOT 
#	  "# Archivo $archguardarcongnus.paraplot; preparado por $progname
##    $ref1->{APARTIR}\n#    $ref1->{COPIADO}\n";
#        print $PARAPLOT  '#'.'-' x 10 .
#            " para pedir graficos a simusol3.pl\n";
#      print $PARAPLOT "$paraplot";
#      close($PARAPLOT);     
#      };
    Simusol::AyudasPP::comfin('finP prograficar');
   return ($paraplot,$tradvar);
}#prograficar
# ---------------------------------------------------------------------------




# ----------------------------------------------------------------------------
sub prograficarVIEJO{
 Simusol::AyudasPP::comfin('comP prograficar',@_);
 # prepara archivo .paraplot con información para gráficos.

  my ($refcircuito) = @_;

  my $archguardar = $refcircuito->{PROPIOSINDIA}; 
  my $archguardarcongnus = $refcircuito->{CORTOSINDIA};
  my $PROPIO = $refcircuito->{PROPIO};
  my $CORTO = $refcircuito->{CORTO};
  my $date = scalar localtime((stat "$CORTO")[9]);
  if ($todas) {
      $archguardar = "$archguardar"."_$todas";
      $archguardar=~ s/\s+/_/g;
      $archguardarcongnus =~ s/([^\/]+)$/gnus\/$1/;
      $refcircuito->{refvalores}->{GRAFICOS} = undef;
  };
  # en el hash apuntado por $refcircuito espera encontrar varias keys:
  my $paraplotSIMULADO = '';
  if ($refcircuito->{clasearch} eq 'circuito') {
      $paraplotSIMULADO = ident_simulado($refcircuito,$archguardar)
  };
  my ($paraplot, $haysimulado, @uniprilista) = ('',0,());
  #Simusol::Globales::impr_debug(__LINE__.' Prog $refcircuito', Dumper $refcircuito);
  if (defined $refcircuito->{refvalores}->{GRAFICOS}) {
      my %todos = %{$refcircuito->{refvalores}->{GRAFICOS}}; 
      foreach (keys %todos) {
          my $vielista = $todos{$_};
          my @vielista = Simusol::AyudasPP::juntar_por_signos_y_paren(',', @$vielista);
	  #Simusol::Globales::impr_debug(__LINE__.' Prog @vielista', \@vielista);
          my @pegados = grep (/=.*=/,@vielista);
          if (@pegados) { 
               Simusol::AyudasPP::avnoseent("Los \"renglones\" del cuadro GRAFICOS\n" .
                        join ("\n", @pegados) . "
             quizás un renglón terminado por error con coma 
                  se pegó al siguiente");
          };                     
          @vielista = grep($_!~ /=.*=/,@vielista);
	  #Simusol::Globales::impr_debug(__LINE__.' Prog @vielista', \@vielista);

          @vielista and do{
               $paraplot = $paraplotSIMULADO . join("\n",@vielista). "\n"; 
          };
          $haysimulado += scalar (grep(/=\s*SIMULADO\s*\,/i,@vielista));
          push @uniprilista, grep(/unipri\s*SIMULADO/,@vielista);   
      }; #foreach 
      #Simusol::Globales::impr_debug(__LINE__.' Prog $haysimulado @uniprilista',
      #        , [$haysimulado, @uniprilista]);
      $haysimulado and @uniprilista == 0 and
          $paraplot .= "unipri SIMULADO = $unidadtiempo\n";  
      #Simusol::Globales::impr_debug(__LINE__.' Prog $paraplot', $paraplot); 
  } else {
      my $tradvar;
      (my $paraplottextos, $haysimulado,$tradvar)
           = inventar_graficos($refcircuito, $archguardar);
      if ($paraplottextos) {
          $paraplot = "$paraplotSIMULADO$paraplottextos";
      } else {
          Simusol::AyudasPP::mensaje("No hay pedido de gráficos, directo ni por defecto");
           Simusol::AyudasPP::comfin('finP prograficar');
          return 1;
      };
  };
  #Simusol::Globales::impr_debug(__LINE__.' Prog $paraplot $archguardarcongnus'
  #              ,[$paraplot,$archguardarcongnus]);
 
 Simusol::AyudasPP::comfin('finP prograficar');
 
 return ($paraplot);
}# prograficar


1;
